<template>
    <div v-if="config!=null" class="h-100">
        <h3 class="text-center div_title">Réglages</h3>

        <div class="container-form">
            <h4><b-icon icon="info-circle" aria-hidden="true"></b-icon> Informations générales</h4>

            <b-row class="font_size_13">
                <b-col :cols="12">
                    <FormTextInput v-bind:label="'Titre de la carte'"
                      v-model="contextService.currentApplication.display_name"/>
                </b-col>
                <b-col :cols="12">
                    <FormTextInput v-bind:label="'Description de la carte'"
                      v-model="contextService.currentApplication.description"/>
                </b-col>
            </b-row>

            <b-row class="mb-3 font_size_13" align-v="center">
                <b-col :cols="5">
                    <b-form-file v-model="contextService.currentApplication.thumbnail"
                    :state="Boolean(contextService.currentApplication.thumbnail)"
                    placeholder="Importer une image "
                    drop-placeholder="Déposer l'image ici"></b-form-file>
                </b-col>
                <b-col :cols="2" class="text-center text-first bold">
                    OU
                </b-col>
                <b-col :cols="5" class="text-center">
                    <b-button variant="outline-secondary" title="Capture Ecran"
                    @click="captureScreen()" class="w-100 font_size_13">
                        Faire une copie d'écran
                    </b-button>
                </b-col>
            </b-row>
            <div class="mt-3 mb-3">
            <img v-if="contextService.currentApplication.thumbnail!==undefined"
                    class="d-block img-fluid w-100"
                    :src="thumbnailSrc"
                    alt="image slot"
                >
                </div>
            <h4><b-icon icon="signpost2" aria-hidden="true"></b-icon> Localisation de la carte </h4>

            <b-row no-gutters class="mb-4 font_size_13" align-v="end">
                <b-col :cols="4"  :xl="2" class="text-center px-1">
                    <label>Centre X</label>
                    <input type="number" min="-180" max="180" step="0.01"
                    class="form-control form-control-sm" v-model="config.coords[0]"/>
                </b-col>
                <b-col :cols="4"  :xl="2" class="text-center px-1">
                    <label>Centre Y</label>
                    <input type="number" min="-180" max="180" step="0.01"
                    class="form-control form-control-sm" v-model="config.coords[1]"/>
                </b-col>
                <b-col :cols="4"  :xl="2" class="text-center px-1">
                    <label>Zoom</label>
                    <input type="number" min="0" max="20" step="0.1"
                    class="form-control form-control-sm" v-model="config.zoom"/>
                </b-col>
                <b-col :cols="1" class="text-center text-first bold">
                    <label>OU</label>
                </b-col>
                <b-col cols="12" md="5">
                    <b-button size="sm" variant="outline-secondary"
                    class="w-100 mt-1" @click="useMapBounds()">Emprise courante de la carte</b-button>
                </b-col>
            </b-row>

            <p class="italic font_size_13 justify text-second">
                <b-icon icon="info-circle" aria-hidden="true" class="text-second"></b-icon>
                Cliquez sur le bouton ci-dessus pour définir la vue courante
                comme emprise initiale de la carte.
                Vous pouvez aussi entrer manuellement les coordonnées et le niveau de zoom souhaités
            </p>
            <div v-if="debug">
              <h4><b-icon icon="globe" aria-hidden="true"></b-icon> Projection de la carte </h4>
              <FormTextInput v-bind:label="'Projection '"
                      v-model="config.projection"/>
            </div>
            <div>
              <h4><b-icon icon="shield-lock" aria-hidden="true"></b-icon> Gestion des droits </h4>
              <b-row class="font_size_13 mb-3">
                <b-col cols="6" >
                  <b-form-checkbox
                    v-model="contextService.currentApplication.public_access" switch>
                      Carte publique
                  </b-form-checkbox>
                </b-col>
              </b-row>
              <p class="italic font_size_13 justify text-second">
                  <b-icon icon="info-circle" aria-hidden="true" class="text-second"></b-icon>
                Si cette case est décochée, la carte sera visible uniquement
                par les membres de mon organisation
              </p>
            </div>
            <div v-if="is3DView()">
              <h4><b-icon icon="sun" aria-hidden="true"></b-icon> Affichage 3D </h4>
              <b-row class="font_size_13 mb-3">
                <b-col cols="6" >
                  <b-form-checkbox
                    v-model="config.cesiumParameters.timeline" switch>
                      Afficher la barre temporelle
                  </b-form-checkbox>
                </b-col>
              </b-row>
              <b-row class="font_size_13 mb-3">
                <b-col cols="6" >
                  <b-form-checkbox
                    v-model="config.cesiumParameters.shadows" switch>
                      Afficher les ombres
                  </b-form-checkbox>
                </b-col>
              </b-row>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import MapContext from '@/models/map-context/MapContext';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';

@Component({
  props: {},
  components: {
    FormTextInput,
  },
})
export default class SettingsPanel extends BaseComponent {
  static ID = 'SettingsPanel';

  config:MapContext|null = null;

  file1 = null;

  blobCapture:any = null;

  mounted() {
    this.config = this.getMapService().config;
  }

  captureScreen() {
    const newCanvas = document.createElement('canvas');
    const mapContext:any = newCanvas.getContext('2d');
    const mapcanvas:any = document.getElementsByClassName('ol-layer')[0].firstChild;
    // set dimensions
    const dim:any = this.getOpenLayersMapService().map.getSize();
    console.log(dim);

    const delta = (window.innerWidth * 30) / 100;
    // warning: since OL7 canvas size is not the same as map.getSize()
    const mapDelta = Math.round((mapcanvas.width * 30) / 100);

    const width = Math.round(dim[0] - delta);
    const height = Math.round(dim[1]);
    newCanvas.width = width;
    newCanvas.height = height;
    newCanvas.style.width = `${width}`;
    newCanvas.style.height = `${height}`;

    Array.prototype.forEach.call(
      document.querySelectorAll('.ol-layer canvas'),
      (canvas) => {
        if (canvas.width > 0) {
          const { opacity } = canvas.parentNode.style;
          mapContext.globalAlpha = opacity === '' ? 1 : Number(opacity);
          const { transform } = canvas.style;
          // Get the transform parameters from the style's transform matrix
          const matrix = transform
            .match(/^matrix\(([^\(]*)\)$/)[1]
            .split(',')
            .map(Number);
          // Apply the transform to the export map context
          CanvasRenderingContext2D.prototype.setTransform.apply(
            mapContext,
            matrix,
          );
          // décalage de l'image pour ne pas afficher la zone cachée par le panneau de gauche
          mapContext.drawImage(canvas, -mapDelta, 0);
        }
      },
    );
    // mapContext.globalAlpha = 1;
    // mapContext.setTransform(1, 0, 0, 1, 0, 0);
    this.blobCapture = newCanvas.toDataURL('image/jpeg', 0.5);
    const blob = this.dataURItoBlob(this.blobCapture);
    const app:any = this.contextService.currentApplication;
    app.setTumbnail(blob);
  }

  dataURItoBlob(dataURI:any) {
    // convert base64/URLEncoded data component to raw binary data held in a string
    let byteString;
    if (dataURI.split(',')[0].indexOf('base64') >= 0) byteString = atob(dataURI.split(',')[1]);
    else byteString = unescape(dataURI.split(',')[1]);

    // separate out the mime component
    const mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

    // write the bytes of the string to a typed array
    const ia = new Uint8Array(byteString.length);
    for (let i = 0; i < byteString.length; i += 1) {
      ia[i] = byteString.charCodeAt(i);
    }

    return new Blob([ia], { type: mimeString });
  }

  useMapBounds() {
    this.getMapService().updateConfigLocationFromMap();
    this.config = this.getMapService().config;
  }

  get thumbnailSrc():any {
    try {
      if (this.blobCapture !== null) {
        return this.blobCapture;
      }
      if (this.contextService.currentApplication !== null) {
        return this.contextService.getThumbnailUrl(this.contextService.currentApplication);
      }
    } catch (error) {
      console.error(error);
      // EventBus.$emit(EVENTS.ERROR, error);
      return '';
    }
    return '';
  }
}
</script>

<style scoped lang="less">

</style>
